/* Problem URL: https://codeforces.com/problemset/problem/475/D */

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

template <class T, class comp = less<>>
using ordered_set = tree<T, null_type , comp , rb_tree_tag , tree_order_statistics_node_update>;

#define V vector

#define rmin(a, b) a = min(a, b)
#define rmax(a, b) a = max(a, b)

#define rep(i, lim) for (int i = 0; i < (lim); i++)
#define nrep(i, s, lim) for (int i = s; i < (lim); i++)

#define repv(i, v) for (auto &i : (v))
#define fillv(v) for (auto &itr_ : (v)) { cin >> itr_; }
#define sortv(v) sort(v.begin(), v.end())
#define all(v) (v).begin(), (v).end()

using vi = vector<int>;
using vvi = vector<vi>;
using vvvi = vector<vvi>;
using vvvvi = vector<vvvi>;

using ll = long long;

using vl = vector<ll>;
using vvl = vector<vl>;
using vvvl = vector<vvl>;
using vvvvl = vector<vvvl>;

template<class v>
auto operator<<(ostream &os, const vector<v> &vec)->ostream& {
    os << vec[0];
    for (size_t i = 1; i < vec.size(); i++) {
        os << ' ' << vec[i];
    }
    os << '\n';
    return os;
}

template<class v>
auto operator>>(istream &is, vector<v> &vec)->istream& {
    for (auto &i : vec) {
        is >> i;
    }
    return is;
}

template<class v>
auto operator<<(ostream &os, const vector<vector<v>> &vec)->ostream& {
    for (auto &i : vec) {
        os << i[0];
        for (size_t j = 1; j < i.size(); j++) {
            os << ' ' << i[j];
        }
        os << '\n';
    }
    return os;
}

template<class v>
auto operator>>(istream  &is, vector<vector<v>> &vec)->istream& {
    for (auto &i : vec) {
        for (auto &j : i) {
            is >> j;
        }
    }
    return is;
}

const int oo = INT32_MAX >> 1;
const ll OO = INT64_MAX >> 1;


void pre()
{

}

#define TEST 0

void solve()
{
    int n;
    cin >> n;
    vl a(n);
    cin >> a;

    // map<ll, ll> count;
    //
    // V<map<ll, ll>> g(n);
    // g[0][a[0]] = 1;
    // count[a[0]]++;
    //
    // nrep(i, 1, n) {
    //     g[i][a[i]] = 1;
    //     repv(j, g[i - 1]) {
    //         g[i][gcd(a[i], j.first)] += j.second;
    //     }
    //
    //     repv(j, g[i]) {
    //         count[j.first] += j.second;
    //     }
    // }
    //
    // int q;
    // cin >> q;
    // while (q--) {
    //     ll a;
    //     cin >> a;
    //     cout << count[a] << '\n';
    // }

    vvl sparse(20, vl(n));
    rep(i, n) {
        sparse[0][i] = a[i];
    }

    nrep(j, 1, 20) {
        for (int i = 0; i + (1 << (j - 1)) < n; i++) {
            sparse[j][i] = gcd(sparse[j - 1][i], sparse[j - 1][i + (1 << (j - 1))]);
        }
    }

    auto query = [&](ll l, ll r) {
        ll log = 31 - __builtin_clz(r - l + 1);
        return gcd(sparse[log][l], sparse[log][r - (1 << log) + 1]);
    };

    map<ll, ll> count;

    rep(i, n) {
        ll r = i;
        while (r < n) {
            ll low = r;
            ll high = n - 1;
            ll cur = r;
            while (low <= high) {
                ll mid = (low + high) >> 1;

                if (query(i, r) == query(i, mid)) {
                    cur = mid;
                    low = mid + 1;
                    continue;
                }

                high = mid - 1;
            }

            count[query(i, cur)] += cur - r + 1;
            r = cur + 1;
        }
    }

    int q;
    cin >> q;
    while (q--) {
        ll x;
        cin >> x;
        cout << count[x] << '\n';
    }
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    pre();

    int t;
    (TEST && cin >> t) || (t = 1);
    while (t--) {
        solve();
    }
}
